/* CALMRISC16 ELF support for BFD.
   Copyright (C) 2000 Free Software Foundation, Inc.

This file is part of BFD, the Binary File Descriptor library.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef _ELF_CALMRISC16_H
#define _ELF_CALMRISC16_H

#include "elf/reloc-macros.h"

/* Relocations.  */
START_RELOC_NUMBERS (elf_calmrisc16_reloc_type)
  RELOC_NUMBER (R_CALMRISC16_NONE, 0)

  RELOC_NUMBER (R_CALMRISC16_32, 1)
  RELOC_NUMBER (R_CALMRISC16_HI6_SHORT, 2)
  RELOC_NUMBER (R_CALMRISC16_HI6_LONG, 3)
  RELOC_NUMBER (R_CALMRISC16_LO16, 4)
  RELOC_NUMBER (R_CALMRISC16_IMM22, 5)
  RELOC_NUMBER (R_CALMRISC16_ELABEL8, 6)
  RELOC_NUMBER (R_CALMRISC16_ELABEL11, 7)
  RELOC_NUMBER (R_CALMRISC16_ELABEL13, 8)

  RELOC_NUMBER (R_CALMRISC16_GNU_VTINHERIT, 9)
  RELOC_NUMBER (R_CALMRISC16_GNU_VTENTRY, 10)
END_RELOC_NUMBERS (R_CALMRISC16_max)

/* Define the data & instruction memory discriminator.  In a linked
   executable, an symbol should be deemed to point to an instruction
   if ((address & CALMRISC16_INSN_MASK) == CALMRISC16_INSN_VALUE), and similarly
   for the data space.  See also `ld/emulparams/elf32calmrisc16.sh'.  */
#define CALMRISC16_DATA_MASK   0xffc00000
#define CALMRISC16_DATA_VALUE  0x00000000
#define CALMRISC16_INSN_MASK   0xffc00000
#define CALMRISC16_INSN_VALUE  0x00400000

#endif /* _ELF_CALMRISC16_H */
