/* Assembler interface for targets using CGEN. -*- C -*-
   CGEN: Cpu tools GENerator

THIS FILE IS MACHINE GENERATED WITH CGEN.
- the resultant file is machine generated, cgen-asm.in isn't

Copyright 1996, 1997, 1998, 1999, 2000, 2001 Free Software Foundation, Inc.

This file is part of the GNU Binutils and GDB, the GNU debugger.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* ??? Eventually more and more of this stuff can go to cpu-independent files.
   Keep that in mind.  */

#include "sysdep.h"
#include <stdio.h>
#include "ansidecl.h"
#include "bfd.h"
#include "symcat.h"
#include "calmrisc16-desc.h"
#include "calmrisc16-opc.h"
#include "opintl.h"
#include "xregex.h"
#include "libiberty.h"
#include "safe-ctype.h"

#undef  min
#define min(a,b) ((a) < (b) ? (a) : (b))
#undef  max
#define max(a,b) ((a) > (b) ? (a) : (b))

static const char * parse_insn_normal
  (CGEN_CPU_DESC, const CGEN_INSN *, const char **, CGEN_FIELDS *);

/* -- assembler routines inserted here.  */

/* -- asm.c */
/* Handle register lists for LDMx and STMx  */

static int
parse_register_number (strp)
     const char **strp;
{
  int regno;
  if (**strp < '0' || **strp > '9')
    return -1; /* error */
  regno = **strp - '0';
  ++*strp;

  if (**strp >= '0' && **strp <= '9')
    {
      regno = regno * 10 + (**strp - '0');
      ++*strp;
    }

  return regno;
}

/* Parse a list of 1 or two general registers, Rn[,Rm].
   They both must be in the same range, either r0-r7 or r8-r14.
   Encode them as mmmmnnn where mmmm is 4 bits representing Rm and nnn is
   3 bits representing Rn. If Rm is not specified, then use the value of Rn.
*/
static const char *
parse_Rlist (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  int Rn, Rm;

  if (**strp == 'R' || **strp == 'r')
    {
      ++*strp;

      Rn = parse_register_number (strp);
      if (Rn == -1)
	return "Register number is not valid";
      if (Rn > 14)
	return "First register must be between r0 and r14";

      Rm = Rn;
      if (**strp == ',')
	{
	  ++*strp;
	  if (**strp == 'R' || **strp == 'r')
	    {
	      ++*strp;
	      Rm = parse_register_number (strp);
	      if (Rm == -1)
		return "Register number is not valid";

	      /* Second register must be in the same range (0-7 or 8-14) as the
		 first.  */
	      if (Rn <= 7)
		{
		  if (Rm > 7)
		    return "Second register must be between r0 and r7";
		}
	      else
		{
		  if (Rm < 8 || Rm > 14)
		    return "Second register must be between r8 and r14";
		}
	    }
	  else
	    return "Second register not specified or not valid";
	}

      *valuep = (Rm << 3) | (Rn & 0x7);
    }

  if (! *strp)
    return "Register list is not valid";

  return NULL;
}

/* Parse a list of 1 or two address registers, An[,Am].
   They both must be in the range a8-a14.
   Encode them as mmmnnn where mmm is 3 bits representing Am and nnn is
   3 bits representing An. If Am is not specified, then use the value of An.
*/
static const char *
parse_Alist (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  int An, Am;

  if (**strp == 'A' || **strp == 'a')
    {
      ++*strp;
      An = parse_register_number (strp);
      if (An == -1)
	return "Register number is not valid";
      if (An < 8 || An > 14)
	return "First register must be between a8 and a14";

      An &= 0x7;
      Am = An;
      if (**strp == ',')
	{
	  ++*strp;
	  if (**strp == 'A' || **strp == 'a')
	    {
	      ++*strp;
	      Am = parse_register_number (strp);
	      if (Am == -1)
		return "Register number is not valid";
	      if (Am < 8 || Am > 14)
		return "Second register must be between a8 and a14";
	      Am &= 0x7;
	    }
	  else
	    return "Second register not specified or not valid";
	}

      *valuep = (Am << 3) | An;
    }

  if (! *strp)
    return "Register list is not valid";

  return NULL;
}

/* Reject %hi and %lo explicitely so that parse_imm16 will get a crack at it
   without an error being generated.  */
static const char *
parse_small_immediate (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  if (**strp == '#')
    ++*strp;
  if (**strp == '%')
    return _("Bad expression");

  return cgen_parse_unsigned_integer (cd, strp, opindex, valuep);
}

/* Parse %hi(...).  */
static const char *
parse_hi_6 (cd, strp, opindex, valuep, bfd_reloc_val)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
     bfd_reloc_code_real_type bfd_reloc_val;
{
  const char *errmsg;
  enum cgen_parse_operand_result result_type;
  bfd_vma value;

  /* '%hi(' has already been seen but not consumed.  */
  *strp += 4;
  errmsg = cgen_parse_address (cd, strp, opindex, bfd_reloc_val,
			       &result_type, &value);
  if (**strp != ')')
    return _("missing `)'");
  ++*strp;
  if (errmsg == NULL && result_type == CGEN_PARSE_OPERAND_RESULT_NUMBER)
    value >>= 16;
  *valuep = value;
  return errmsg;
}

/* Parse %lo(...).  */
static const char *
parse_lo_16 (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  const char *errmsg;
  enum cgen_parse_operand_result result_type;
  bfd_vma value;

  /* '%lo(' has already been seen but not consumed.  */
  *strp += 4;
  errmsg = cgen_parse_address (cd, strp, opindex, BFD_RELOC_CALMRISC16_LO16,
			       &result_type, &value);
  if (**strp != ')')
    return _("missing `)'");
  ++*strp;
  if (errmsg == NULL && result_type == CGEN_PARSE_OPERAND_RESULT_NUMBER)
    value &= 0xffff;
  *valuep = value;
  return errmsg;
}

/* Allow %hi but reject %lo.  */
static const char *
parse_medium_immediate (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  if (**strp == '#')
    ++*strp;

  if (**strp == '%')
    {
      if (strncasecmp (*strp, "%hi(", 4) == 0)
	return parse_hi_6 (cd, strp, opindex, valuep,
			   BFD_RELOC_CALMRISC16_HI6_SHORT);
      return _("Bad expression");
    }

  return cgen_parse_unsigned_integer (cd, strp, opindex, valuep);
}

/* imm13 should be greater than or equal to 0x200.  */
static const char *
parse_imm13 (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  const char *errmsg = cgen_parse_unsigned_integer (cd, strp, opindex, valuep);
  if (! errmsg && *valuep < 0x200)
    return _("Immediate value must not be less than 0x200");
  return errmsg;
}

/* Handle %hi, %lo, <label> and immediate operands.  */
static const char *
parse_imm16 (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  const char *errmsg;
  enum cgen_parse_operand_result result_type;
  bfd_vma value;

  if (**strp == '#')
    ++*strp;

  if (strncasecmp (*strp, "%hi(", 4) == 0)
    return parse_hi_6 (cd, strp, opindex, valuep,
		       BFD_RELOC_CALMRISC16_HI6_LONG);

  if (strncasecmp (*strp, "%lo(", 4) == 0)
    return parse_lo_16 (cd, strp, opindex, valuep);

  return cgen_parse_unsigned_integer (cd, strp, opindex, valuep);
}

/* Parse imm16, but allow negative values in the range -1 to -32767.  */
static const char *
parse_eimm16 (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  const char *errmsg;

  if (**strp == '#')
    ++*strp;

  /* Accept negative values in the range -1 (0xffff) to -32768 (0x8000).  */
  if (**strp == '-')
    {
      long svalue;
      errmsg = cgen_parse_signed_integer (cd, strp, opindex, &svalue);
      if (errmsg != NULL)
	return errmsg;
      /* Accept these negative values, but massage the result so that it looks
	 like a positive 16 bit value with the same bit pattern.  */
      if (svalue <= -1 && svalue >= ~0x7fff)
	{
	  *valuep = svalue & 0xffff;
	  return NULL;
	}
      return _("Immediate value is out of range");
    }

  errmsg = parse_imm16 (cd, strp, opindex, valuep);
  return errmsg;
}

/* Parse imm22, but allow negative values in the range -1 to -2097152.  */
static const char *
parse_eimm22 (cd, strp, opindex, valuep)
     CGEN_CPU_DESC cd;
     const char **strp;
     int opindex;
     unsigned long *valuep;
{
  const char *errmsg;

  if (**strp == '#')
    ++*strp;

  /* Accept negative values in the range -1 (0x3fffff) to -2097152 (0x200000).
   */
  if (**strp == '-')
    {
      long svalue;
      errmsg = cgen_parse_signed_integer (cd, strp, opindex, &svalue);
      if (errmsg != NULL)
	return errmsg;
      /* Accept these negative values, but massage the result so that it looks
	 like a positive 22 bit value with the same bit pattern.  */
      if (svalue <= -1 && svalue >= ~0x1fffff)
	{
	  *valuep = svalue & 0x3fffff;
	  return NULL;
	}
      return _("Immediate value is out of range");
    }

  if (strncasecmp (*strp, "%hi(", 4) == 0)
    return parse_hi_6 (cd, strp, opindex, valuep,
		       BFD_RELOC_CALMRISC16_HI6_LONG);

  if (strncasecmp (*strp, "%lo(", 4) == 0)
    return parse_lo_16 (cd, strp, opindex, valuep);

  errmsg = cgen_parse_unsigned_integer (cd, strp, opindex, valuep);
  return errmsg;
}
/* -- */

const char * calmrisc16_cgen_parse_operand
  PARAMS ((CGEN_CPU_DESC, int, const char **, CGEN_FIELDS *));

/* Main entry point for operand parsing.

   This function is basically just a big switch statement.  Earlier versions
   used tables to look up the function to use, but
   - if the table contains both assembler and disassembler functions then
     the disassembler contains much of the assembler and vice-versa,
   - there's a lot of inlining possibilities as things grow,
   - using a switch statement avoids the function call overhead.

   This function could be moved into `parse_insn_normal', but keeping it
   separate makes clear the interface between `parse_insn_normal' and each of
   the handlers.  */

const char *
calmrisc16_cgen_parse_operand (cd, opindex, strp, fields)
     CGEN_CPU_DESC cd;
     int opindex;
     const char ** strp;
     CGEN_FIELDS * fields;
{
  const char * errmsg = NULL;
  /* Used by scalar operands that still need to be parsed.  */
  long junk ATTRIBUTE_UNUSED;

  switch (opindex)
    {
    case CALMRISC16_OPERAND_AI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_ar_names, & fields->f_An1);
      break;
    case CALMRISC16_OPERAND_AI1 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_ar_names, & fields->f_An2);
      break;
    case CALMRISC16_OPERAND_ALIST :
      errmsg = parse_Alist (cd, strp, CALMRISC16_OPERAND_ALIST, &fields->f_Alist);
      break;
    case CALMRISC16_OPERAND_AN :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_ar_names, & fields->f_An);
      break;
    case CALMRISC16_OPERAND_AN1 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_ar_names, & fields->f_An1);
      break;
    case CALMRISC16_OPERAND_AN2 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_ar_names, & fields->f_An2);
      break;
    case CALMRISC16_OPERAND_DI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Dn);
      break;
    case CALMRISC16_OPERAND_DI1 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Dn1);
      break;
    case CALMRISC16_OPERAND_DN :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Dn);
      break;
    case CALMRISC16_OPERAND_DN1 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Dn1);
      break;
    case CALMRISC16_OPERAND_EI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_er_names, & fields->f_En);
      break;
    case CALMRISC16_OPERAND_EN :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_er_names, & fields->f_En);
      break;
    case CALMRISC16_OPERAND_H :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_H);
      break;
    case CALMRISC16_OPERAND_RI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Rn1);
      break;
    case CALMRISC16_OPERAND_RI1 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Rn);
      break;
    case CALMRISC16_OPERAND_RJ :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Rn1);
      break;
    case CALMRISC16_OPERAND_RLIST :
      errmsg = parse_Rlist (cd, strp, CALMRISC16_OPERAND_RLIST, &fields->f_Rlist);
      break;
    case CALMRISC16_OPERAND_RM :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Rm);
      break;
    case CALMRISC16_OPERAND_RN :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Rn);
      break;
    case CALMRISC16_OPERAND_RN1 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_gr_names, & fields->f_Rn1);
      break;
    case CALMRISC16_OPERAND_RS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_spr_names, & fields->f_Rs);
      break;
    case CALMRISC16_OPERAND_BS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cbs_names, & fields->f_op4);
      break;
    case CALMRISC16_OPERAND_BS3 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_BS3, &fields->f_bs3);
      break;
    case CALMRISC16_OPERAND_CAN11 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_CAN12 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op12_2);
      break;
    case CALMRISC16_OPERAND_CAN14 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_CAN9 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op9_2);
      break;
    case CALMRISC16_OPERAND_CAI12 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_CCI10 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_cci10);
      break;
    case CALMRISC16_OPERAND_CCI11 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_cci11);
      break;
    case CALMRISC16_OPERAND_CCI13 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_cci13);
      break;
    case CALMRISC16_OPERAND_CIMM16 :
      errmsg = parse_eimm16 (cd, strp, CALMRISC16_OPERAND_CIMM16, &fields->f_imm16c);
      break;
    case CALMRISC16_OPERAND_DISP16 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_DISP16, &fields->f_disp16);
      break;
    case CALMRISC16_OPERAND_DISP4 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_DISP4, &fields->f_disp4);
      break;
    case CALMRISC16_OPERAND_DISP8 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_DISP8, &fields->f_disp8);
      break;
    case CALMRISC16_OPERAND_DIX :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cdi_names, & fields->f_op13_1);
      break;
    case CALMRISC16_OPERAND_EC2 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_h_ec2, & fields->f_ec2);
      break;
    case CALMRISC16_OPERAND_EDISP5 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_EDISP5, &fields->f_edisp5);
      break;
    case CALMRISC16_OPERAND_EDISP9 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_EDISP9, &fields->f_edisp9);
      break;
    case CALMRISC16_OPERAND_EIMM16 :
      errmsg = parse_eimm16 (cd, strp, CALMRISC16_OPERAND_EIMM16, &fields->f_imm16);
      break;
    case CALMRISC16_OPERAND_EIMM22 :
      errmsg = parse_eimm22 (cd, strp, CALMRISC16_OPERAND_EIMM22, &fields->f_imm22);
      break;
    case CALMRISC16_OPERAND_ELABEL11 :
      {
        bfd_vma value;
        errmsg = cgen_parse_address (cd, strp, CALMRISC16_OPERAND_ELABEL11, 0, NULL,  & value);
        fields->f_eoffset11 = value;
      }
      break;
    case CALMRISC16_OPERAND_ELABEL13 :
      {
        bfd_vma value;
        errmsg = cgen_parse_address (cd, strp, CALMRISC16_OPERAND_ELABEL13, 0, NULL,  & value);
        fields->f_eoffset13 = value;
      }
      break;
    case CALMRISC16_OPERAND_ELABEL8 :
      {
        bfd_vma value;
        errmsg = cgen_parse_address (cd, strp, CALMRISC16_OPERAND_ELABEL8, 0, NULL,  & value);
        fields->f_eoffset8 = value;
      }
      break;
    case CALMRISC16_OPERAND_EREG_CAHR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cahr_names, & fields->f_op10_2);
      break;
    case CALMRISC16_OPERAND_EREG_CAR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op10_2);
      break;
    case CALMRISC16_OPERAND_EREG_CSR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csr_names, & fields->f_op10_2);
      break;
    case CALMRISC16_OPERAND_IMM13 :
      errmsg = parse_imm13 (cd, strp, CALMRISC16_OPERAND_IMM13, &fields->f_imm13);
      break;
    case CALMRISC16_OPERAND_IMM16 :
      errmsg = parse_imm16 (cd, strp, CALMRISC16_OPERAND_IMM16, &fields->f_imm16);
      break;
    case CALMRISC16_OPERAND_IMM2 :
      errmsg = parse_small_immediate (cd, strp, CALMRISC16_OPERAND_IMM2, &fields->f_imm2);
      break;
    case CALMRISC16_OPERAND_IMM22 :
      errmsg = cgen_parse_unsigned_integer (cd, strp, CALMRISC16_OPERAND_IMM22, &fields->f_imm22);
      break;
    case CALMRISC16_OPERAND_IMM4 :
      errmsg = parse_small_immediate (cd, strp, CALMRISC16_OPERAND_IMM4, &fields->f_imm4);
      break;
    case CALMRISC16_OPERAND_IMM5 :
      errmsg = parse_small_immediate (cd, strp, CALMRISC16_OPERAND_IMM5, &fields->f_imm5);
      break;
    case CALMRISC16_OPERAND_IMM6 :
      errmsg = parse_medium_immediate (cd, strp, CALMRISC16_OPERAND_IMM6, &fields->f_imm6);
      break;
    case CALMRISC16_OPERAND_IMM7 :
      errmsg = parse_medium_immediate (cd, strp, CALMRISC16_OPERAND_IMM7, &fields->f_imm7);
      break;
    case CALMRISC16_OPERAND_IMM8 :
      errmsg = parse_medium_immediate (cd, strp, CALMRISC16_OPERAND_IMM8, &fields->f_imm8);
      break;
    case CALMRISC16_OPERAND_MG1_10_CIR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG1_10_CMAR_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_parts_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG1_13_CIR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG1_13_CMAR_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_parts_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG1_8_CIR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op9_2);
      break;
    case CALMRISC16_OPERAND_MG1_8_CMAR_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_parts_names, & fields->f_op9_2);
      break;
    case CALMRISC16_OPERAND_MG11_CMAR_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_parts_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG11_CMAR_RND :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_rnd_names, & fields->f_op15_1);
      break;
    case CALMRISC16_OPERAND_MG11_CMAR_SHIFT :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_shift_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG11_CMCR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmcr_names, & fields->f_op15_1);
      break;
    case CALMRISC16_OPERAND_MG11_CP_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cp_parts_names, & fields->f_op15_1);
      break;
    case CALMRISC16_OPERAND_MG11_CRPDR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpdr_names, & fields->f_op15_1);
      break;
    case CALMRISC16_OPERAND_MG11_CRPR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG11_CSR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG11_MG_SPEC :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_mg_spec_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG11_SDR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_sdr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MG8_CMAR_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_parts_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG8_CMAR_RND :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_rnd_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_MG8_CMAR_SHIFT :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_shift_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG8_CMCR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmcr_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_MG8_CP_PARTS :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cp_parts_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_MG8_CRPDR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpdr_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_MG8_CRPR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG8_CSR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csr_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG8_MG_SPEC :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_mg_spec_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MG8_SDR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_sdr_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MGA_CAR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_car_names, & fields->f_op10_1);
      break;
    case CALMRISC16_OPERAND_MGA_CMAR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_names, & fields->f_op10_1);
      break;
    case CALMRISC16_OPERAND_MGX11 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_MGX14 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_MGX9 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op9_2);
      break;
    case CALMRISC16_OPERAND_MI11 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_names, & fields->f_op11_1);
      break;
    case CALMRISC16_OPERAND_MI12 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_MI13 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_names, & fields->f_op13_1);
      break;
    case CALMRISC16_OPERAND_MI8 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmar_names, & fields->f_op8_1);
      break;
    case CALMRISC16_OPERAND_NS_CDI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cdi_names, & fields->f_op11_1);
      break;
    case CALMRISC16_OPERAND_NS_CSI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csi_names, & fields->f_op11_1);
      break;
    case CALMRISC16_OPERAND_PI12 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cp_parts_names, & fields->f_op12_1);
      break;
    case CALMRISC16_OPERAND_PI8 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cp_parts_names, & fields->f_op8_1);
      break;
    case CALMRISC16_OPERAND_RP01 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op15_1);
      break;
    case CALMRISC16_OPERAND_RPDI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpdr_names, & fields->f_op8_1);
      break;
    case CALMRISC16_OPERAND_RPI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_RPI11 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op11_2);
      break;
    case CALMRISC16_OPERAND_RPI14 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_RPUI_CMCR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cmcr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_RPUI_CRPR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_crpr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_RPUI_SDR :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_sdr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_SIX :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csi_names, & fields->f_op13_1);
      break;
    case CALMRISC16_OPERAND_SIX14 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csi_names, & fields->f_op14_1);
      break;
    case CALMRISC16_OPERAND_SP :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_h_a15, & junk);
      break;
    case CALMRISC16_OPERAND_SRG12 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csr_names, & fields->f_op12_2);
      break;
    case CALMRISC16_OPERAND_SRG14 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_SRG9 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_csr_names, & fields->f_op9_2);
      break;
    case CALMRISC16_OPERAND_XI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_xi9);
      break;
    case CALMRISC16_OPERAND_XIYI14 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cxyr_names, & fields->f_op14_2);
      break;
    case CALMRISC16_OPERAND_XIYI7 :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cxyr_names, & fields->f_op7_2);
      break;
    case CALMRISC16_OPERAND_YI :
      errmsg = cgen_parse_keyword (cd, strp, & calmrisc16_cgen_opval_cir_names, & fields->f_op10_1);
      break;

    default :
      /* xgettext:c-format */
      fprintf (stderr, _("Unrecognized field %d while parsing.\n"), opindex);
      abort ();
  }

  return errmsg;
}

cgen_parse_fn * const calmrisc16_cgen_parse_handlers[] = 
{
  parse_insn_normal,
};

void
calmrisc16_cgen_init_asm (cd)
     CGEN_CPU_DESC cd;
{
  calmrisc16_cgen_init_opcode_table (cd);
  calmrisc16_cgen_init_ibld_table (cd);
  cd->parse_handlers = & calmrisc16_cgen_parse_handlers[0];
  cd->parse_operand = calmrisc16_cgen_parse_operand;
}



/* Regex construction routine.

   This translates an opcode syntax string into a regex string,
   by replacing any non-character syntax element (such as an
   opcode) with the pattern '.*'

   It then compiles the regex and stores it in the opcode, for
   later use by calmrisc16_cgen_assemble_insn

   Returns NULL for success, an error message for failure.  */

char * 
calmrisc16_cgen_build_insn_regex (CGEN_INSN *insn)
{  
  CGEN_OPCODE *opc = (CGEN_OPCODE *) CGEN_INSN_OPCODE (insn);
  const char *mnem = CGEN_INSN_MNEMONIC (insn);
  char rxbuf[CGEN_MAX_RX_ELEMENTS];
  char *rx = rxbuf;
  const CGEN_SYNTAX_CHAR_TYPE *syn;
  int reg_err;

  syn = CGEN_SYNTAX_STRING (CGEN_OPCODE_SYNTAX (opc));

  /* Mnemonics come first in the syntax string.  */
  if (! CGEN_SYNTAX_MNEMONIC_P (* syn))
    return _("missing mnemonic in syntax string");
  ++syn;

  /* Generate a case sensitive regular expression that emulates case
     insensitive matching in the "C" locale.  We cannot generate a case
     insensitive regular expression because in Turkish locales, 'i' and 'I'
     are not equal modulo case conversion.  */

  /* Copy the literal mnemonic out of the insn.  */
  for (; *mnem; mnem++)
    {
      char c = *mnem;

      if (ISALPHA (c))
	{
	  *rx++ = '[';
	  *rx++ = TOLOWER (c);
	  *rx++ = TOUPPER (c);
	  *rx++ = ']';
	}
      else
	*rx++ = c;
    }

  /* Copy any remaining literals from the syntax string into the rx.  */
  for(; * syn != 0 && rx <= rxbuf + (CGEN_MAX_RX_ELEMENTS - 7 - 4); ++syn)
    {
      if (CGEN_SYNTAX_CHAR_P (* syn)) 
	{
	  char c = CGEN_SYNTAX_CHAR (* syn);

	  switch (c) 
	    {
	      /* Escape any regex metacharacters in the syntax.  */
	    case '.': case '[': case '\\': 
	    case '*': case '^': case '$': 

#ifdef CGEN_ESCAPE_EXTENDED_REGEX
	    case '?': case '{': case '}': 
	    case '(': case ')': case '*':
	    case '|': case '+': case ']':
#endif
	      *rx++ = '\\';
	      *rx++ = c;
	      break;

	    default:
	      if (ISALPHA (c))
		{
		  *rx++ = '[';
		  *rx++ = TOLOWER (c);
		  *rx++ = TOUPPER (c);
		  *rx++ = ']';
		}
	      else
		*rx++ = c;
	      break;
	    }
	}
      else
	{
	  /* Replace non-syntax fields with globs.  */
	  *rx++ = '.';
	  *rx++ = '*';
	}
    }

  /* Trailing whitespace ok.  */
  * rx++ = '['; 
  * rx++ = ' '; 
  * rx++ = '\t'; 
  * rx++ = ']'; 
  * rx++ = '*'; 

  /* But anchor it after that.  */
  * rx++ = '$'; 
  * rx = '\0';

  //printf("regex(%s) = %s\n", insn->base->name, rxbuf);

  CGEN_INSN_RX (insn) = xmalloc (sizeof (regex_t));
  reg_err = regcomp ((regex_t *) CGEN_INSN_RX (insn), rxbuf, REG_NOSUB);

  if (reg_err == 0) 
    return NULL;
  else
    {
      static char msg[80];

      regerror (reg_err, (regex_t *) CGEN_INSN_RX (insn), msg, 80);
      regfree ((regex_t *) CGEN_INSN_RX (insn));
      free (CGEN_INSN_RX (insn));
      (CGEN_INSN_RX (insn)) = NULL;
      return msg;
    }
}


/* Default insn parser.

   The syntax string is scanned and operands are parsed and stored in FIELDS.
   Relocs are queued as we go via other callbacks.

   ??? Note that this is currently an all-or-nothing parser.  If we fail to
   parse the instruction, we return 0 and the caller will start over from
   the beginning.  Backtracking will be necessary in parsing subexpressions,
   but that can be handled there.  Not handling backtracking here may get
   expensive in the case of the m68k.  Deal with later.

   Returns NULL for success, an error message for failure.  */

static const char *
parse_insn_normal (CGEN_CPU_DESC cd,
		   const CGEN_INSN *insn,
		   const char **strp,
		   CGEN_FIELDS *fields)
{
  /* ??? Runtime added insns not handled yet.  */
  const CGEN_SYNTAX *syntax = CGEN_INSN_SYNTAX (insn);
  const char *str = *strp;
  const char *errmsg;
  const char *p;
  const CGEN_SYNTAX_CHAR_TYPE * syn;
#ifdef CGEN_MNEMONIC_OPERANDS
  /* FIXME: wip */
  int past_opcode_p;
#endif

  /* For now we assume the mnemonic is first (there are no leading operands).
     We can parse it without needing to set up operand parsing.
     GAS's input scrubber will ensure mnemonics are lowercase, but we may
     not be called from GAS.  */
  p = CGEN_INSN_MNEMONIC (insn);
  while (*p && TOLOWER (*p) == TOLOWER (*str))
    ++p, ++str;

  if (* p)
    return _("unrecognized instruction");

#ifndef CGEN_MNEMONIC_OPERANDS
  if (* str && ! ISSPACE (* str))
    return _("unrecognized instruction");
#endif

  CGEN_INIT_PARSE (cd);
  cgen_init_parse_operand (cd);
#ifdef CGEN_MNEMONIC_OPERANDS
  past_opcode_p = 0;
#endif

  /* We don't check for (*str != '\0') here because we want to parse
     any trailing fake arguments in the syntax string.  */
  syn = CGEN_SYNTAX_STRING (syntax);

  /* Mnemonics come first for now, ensure valid string.  */
  if (! CGEN_SYNTAX_MNEMONIC_P (* syn))
    abort ();

  ++syn;

  while (* syn != 0)
    {
      /* Non operand chars must match exactly.  */
      if (CGEN_SYNTAX_CHAR_P (* syn))
	{
	  /* FIXME: While we allow for non-GAS callers above, we assume the
	     first char after the mnemonic part is a space.  */
	  /* FIXME: We also take inappropriate advantage of the fact that
	     GAS's input scrubber will remove extraneous blanks.  */
	  if (TOLOWER (*str) == TOLOWER (CGEN_SYNTAX_CHAR (* syn)))
	    {
#ifdef CGEN_MNEMONIC_OPERANDS
	      if (CGEN_SYNTAX_CHAR(* syn) == ' ')
		past_opcode_p = 1;
#endif
	      ++ syn;
	      ++ str;
	    }
	  else if (*str)
	    {
	      /* Syntax char didn't match.  Can't be this insn.  */
	      static char msg [80];

	      /* xgettext:c-format */
	      sprintf (msg, _("syntax error (expected char `%c', found `%c')"),
		       CGEN_SYNTAX_CHAR(*syn), *str);
	      return msg;
	    }
	  else
	    {
	      /* Ran out of input.  */
	      static char msg [80];

	      /* xgettext:c-format */
	      sprintf (msg, _("syntax error (expected char `%c', found end of instruction)"),
		       CGEN_SYNTAX_CHAR(*syn));
	      return msg;
	    }
	  continue;
	}

      /* We have an operand of some sort.  */
      errmsg = cd->parse_operand (cd, CGEN_SYNTAX_FIELD (*syn),
					  &str, fields);
      if (errmsg)
	return errmsg;

      /* Done with this operand, continue with next one.  */
      ++ syn;
    }

  /* If we're at the end of the syntax string, we're done.  */
  if (* syn == 0)
    {
      /* FIXME: For the moment we assume a valid `str' can only contain
	 blanks now.  IE: We needn't try again with a longer version of
	 the insn and it is assumed that longer versions of insns appear
	 before shorter ones (eg: lsr r2,r3,1 vs lsr r2,r3).  */
      while (ISSPACE (* str))
	++ str;

      if (* str != '\0')
	return _("junk at end of line"); /* FIXME: would like to include `str' */

      return NULL;
    }

  /* We couldn't parse it.  */
  return _("unrecognized instruction");
}

/* Main entry point.
   This routine is called for each instruction to be assembled.
   STR points to the insn to be assembled.
   We assume all necessary tables have been initialized.
   The assembled instruction, less any fixups, is stored in BUF.
   Remember that if CGEN_INT_INSN_P then BUF is an int and thus the value
   still needs to be converted to target byte order, otherwise BUF is an array
   of bytes in target byte order.
   The result is a pointer to the insn's entry in the opcode table,
   or NULL if an error occured (an error message will have already been
   printed).

   Note that when processing (non-alias) macro-insns,
   this function recurses.

   ??? It's possible to make this cpu-independent.
   One would have to deal with a few minor things.
   At this point in time doing so would be more of a curiosity than useful
   [for example this file isn't _that_ big], but keeping the possibility in
   mind helps keep the design clean.  */

const CGEN_INSN *
calmrisc16_cgen_assemble_insn (CGEN_CPU_DESC cd,
			   const char *str,
			   CGEN_FIELDS *fields,
			   CGEN_INSN_BYTES_PTR buf,
			   char **errmsg)
{
  const char *start;
  CGEN_INSN_LIST *ilist;
  const char *parse_errmsg = NULL;
  const char *insert_errmsg = NULL;
  int recognized_mnemonic = 0;

  /* Skip leading white space.  */
  while (ISSPACE (* str))
    ++ str;

  /* The instructions are stored in hashed lists.
     Get the first in the list.  */
  ilist = CGEN_ASM_LOOKUP_INSN (cd, str);

  /* Keep looking until we find a match.  */
  start = str;
  for ( ; ilist != NULL ; ilist = CGEN_ASM_NEXT_INSN (ilist))
    {
      const CGEN_INSN *insn = ilist->insn;
      recognized_mnemonic = 1;

#ifdef CGEN_VALIDATE_INSN_SUPPORTED 
      /* Not usually needed as unsupported opcodes
	 shouldn't be in the hash lists.  */
      /* Is this insn supported by the selected cpu?  */
      if (! calmrisc16_cgen_insn_supported (cd, insn))
	continue;
#endif
      /* If the RELAXED attribute is set, this is an insn that shouldn't be
	 chosen immediately.  Instead, it is used during assembler/linker
	 relaxation if possible.  */
      if (CGEN_INSN_ATTR_VALUE (insn, CGEN_INSN_RELAXED) != 0)
	continue;

      str = start;

      //
      //printf("Checking insn %s\n", insn->base->name);

      /* Skip this insn if str doesn't look right lexically.  */
      if (CGEN_INSN_RX (insn) != NULL &&
	  regexec ((regex_t *) CGEN_INSN_RX (insn), str, 0, NULL, 0) == REG_NOMATCH)
	continue;
      //printf("ok1\n");

      /* Allow parse/insert handlers to obtain length of insn.  */
      CGEN_FIELDS_BITSIZE (fields) = CGEN_INSN_BITSIZE (insn);

      parse_errmsg = CGEN_PARSE_FN (cd, insn) (cd, insn, & str, fields);
      if (parse_errmsg != NULL) {
	//	printf("Error = %s\n", parse_errmsg);
	continue;
      }
      //printf("ok2\n");

      /* ??? 0 is passed for `pc'.  */
      insert_errmsg = CGEN_INSERT_FN (cd, insn) (cd, insn, fields, buf,
						 (bfd_vma) 0);
      if (insert_errmsg != NULL)
        continue;
      //printf("ok3\n");

      /* It is up to the caller to actually output the insn and any
         queued relocs.  */
      return insn;
    }

  {
    static char errbuf[150];
#ifdef CGEN_VERBOSE_ASSEMBLER_ERRORS
    const char *tmp_errmsg;

    /* If requesting verbose error messages, use insert_errmsg.
       Failing that, use parse_errmsg.  */
    tmp_errmsg = (insert_errmsg ? insert_errmsg :
		  parse_errmsg ? parse_errmsg :
		  recognized_mnemonic ?
		  _("unrecognized form of instruction") :
		  _("unrecognized instruction"));

    if (strlen (start) > 50)
      /* xgettext:c-format */
      sprintf (errbuf, "%s `%.50s...'", tmp_errmsg, start);
    else 
      /* xgettext:c-format */
      sprintf (errbuf, "%s `%.50s'", tmp_errmsg, start);
#else
    if (strlen (start) > 50)
      /* xgettext:c-format */
      sprintf (errbuf, _("bad instruction `%.50s...'"), start);
    else 
      /* xgettext:c-format */
      sprintf (errbuf, _("bad instruction `%.50s'"), start);
#endif
      
    *errmsg = errbuf;
    return NULL;
  }
}

#if 0 /* This calls back to GAS which we can't do without care.  */

/* Record each member of OPVALS in the assembler's symbol table.
   This lets GAS parse registers for us.
   ??? Interesting idea but not currently used.  */

/* Record each member of OPVALS in the assembler's symbol table.
   FIXME: Not currently used.  */

void
calmrisc16_cgen_asm_hash_keywords (CGEN_CPU_DESC cd, CGEN_KEYWORD *opvals)
{
  CGEN_KEYWORD_SEARCH search = cgen_keyword_search_init (opvals, NULL);
  const CGEN_KEYWORD_ENTRY * ke;

  while ((ke = cgen_keyword_search_next (& search)) != NULL)
    {
#if 0 /* Unnecessary, should be done in the search routine.  */
      if (! calmrisc16_cgen_opval_supported (ke))
	continue;
#endif
      cgen_asm_record_register (cd, ke->name, ke->value);
    }
}

#endif /* 0 */
